package com.tibco.contrib;

import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.streambase.liveview.client.LiveViewException;
import com.streambase.liveview.client.LiveViewExceptionType;
import com.streambase.liveview.client.LiveViewQueryType;
import com.streambase.liveview.server.query.ParsedExpr;
import com.streambase.liveview.server.query.QueryModelBase;
import com.streambase.liveview.server.query.QueryUtil;
import com.streambase.liveview.server.table.CatalogedTable;

public class ExcelQueryModel extends QueryModelBase  {

	private final ExcelTable excelTable;
//    private static final String PARSE_PATTERN_FORMATTER = "^\\s*select\\s+(.*)\\s+from[\\s.]+%s(\\s+where\\s+(.*?))?(\\s+limit\\s+(.*))?$";
    private static final int INDEX_PROJECTION = 1;
    private static final int INDEX_PREDICATE = 3;
    private static final int INDEX_LIMIT = 5;
    
    private int limit=Integer.MAX_VALUE;
	
	public ExcelQueryModel(CatalogedTable catalogedTable, ExcelTable excelTable, String queryString) {
        super(catalogedTable, queryString, LiveViewQueryType.SNAPSHOT);
        this.excelTable = excelTable;
        resultSchema=excelTable.getSchema();
	}
	
	@Override
	public List<String> getDirection() throws UnsupportedOperationException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<ParsedExpr> getGroupBy() throws UnsupportedOperationException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int getLimit() throws UnsupportedOperationException {
		return limit;
	}

	@Override
	public List<ParsedExpr> getOrderBy() throws UnsupportedOperationException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getPredicate() {
		return queryString;
	}

	@Override
	public String getProjection() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getTable() {
		return excelTable.getTableName();
	}

	@Override
	public long getTemporalPredicateComponent()
			throws UnsupportedOperationException {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public String getTimestampField() throws UnsupportedOperationException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getWindowEndExpr() throws UnsupportedOperationException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getWindowStartExpr() throws UnsupportedOperationException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean hasGroupBy() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean hasLimit() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean hasOrderBy() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean hasPredicate() {
		return (queryString!=null) && (!queryString.isEmpty());
	}

	@Override
	public boolean hasTemporalPredicate() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean hasTimeWindowedPredicate() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void validate(CatalogedTable arg0, boolean includeInternalFields) throws LiveViewException {
		if ((queryString == null) || queryString.isEmpty()) {
			return;
		}
		
		//     private static final String PARSE_PATTERN_FORMATTER = "^\\s*select\\s+(.*)\\s+from\\s+%s(\\s+where\\s+(.*?))?(\\s+limit\\s+(.*))?$";

	    String PARSE_PATTERN_FORMATTER = "^\\s*select\\s+(.*)\\s+from\\s+\\S+(\\s+where\\s+(.*?))?(\\s+limit\\s+(.*))?$";
	    
        final String regex = String.format(PARSE_PATTERN_FORMATTER, excelTable.getTableName());
        Pattern queryParsePattern = Pattern.compile(regex, Pattern.CASE_INSENSITIVE);
        Matcher matcher = queryParsePattern.matcher(queryString);
        if (!matcher.matches()) {
            throw LiveViewExceptionType.QUERY_SYNTAX.error();
        }
        
        String projection = matcher.group(INDEX_PROJECTION);
        queryString = QueryUtil.processPredicate(matcher.group(INDEX_PREDICATE), catalogedTable.getPredicateFilter());
        
        final String limitStr = matcher.group(INDEX_LIMIT);
        try {
            limit = limitStr == null ? Integer.MAX_VALUE : Integer.parseInt(limitStr);
        } catch (NumberFormatException e) {
            throw LiveViewExceptionType.QUERY_SYNTAX.error();
        }
        
        if (projection == null) {
            throw LiveViewExceptionType.QUERY_SYNTAX.error();
        }

        if (queryString == null || queryString.equalsIgnoreCase("true")) {
        	return;
        }
		String[] q=queryString.split(",");
		if (q.length > 2) {
			throw LiveViewExceptionType.INVALID_QUERY.error(String.format("Must be firstRow[,LastRow]: %s", queryString));
		}
		
		Integer start;
		try {
			start=new Integer(q[0]);
		} catch (Exception e) {
			throw LiveViewExceptionType.INVALID_QUERY.error(String.format("first row not an integer: %s", queryString));
		}
		if (start < 1) {
			throw LiveViewExceptionType.INVALID_QUERY.error(String.format("The first row starts at 1: %s", queryString));
		}
		
		if (q.length == 2) {
			try {
				new Integer(q[1]);
			} catch (Exception e) {
				throw LiveViewExceptionType.INVALID_QUERY.error(String.format("last row not an integer: %s", queryString));
			}
		}
	}

}
