package com.tibco.contrib;

import java.util.ArrayList;
import java.util.List;

import com.streambase.liveview.client.LiveViewException;
import com.streambase.liveview.server.table.plugin.TableNameMapper;
import com.streambase.liveview.server.table.plugin.TableProvider;
import com.streambase.liveview.server.table.plugin.TableProviderControl;
import com.streambase.liveview.server.table.plugin.TableProviderParameters;

/*
 * This is the Excel table provide sample
 */
public class ExcelTableProvider implements TableProvider {

	private static final String PATH_NAME = "pathname";
	public static final String ROW_COLUMN_NAME ="RowNumber";
	
	private String providerId;
	private TableProviderControl helper;
	private TableNameMapper mapper;
	private List<String> pathNames;
	
	private List<ExcelTable> etList = new ArrayList<ExcelTable>();

	@Override
	public void initialize(String id, TableProviderControl helper, TableProviderParameters parameters, TableNameMapper mapper)
			throws LiveViewException {
		this.providerId=id;
		this.helper=helper;
		this.mapper=mapper;

		// Get the names of the Excel files
		pathNames = parameters.getMultivalue(PATH_NAME);
	}

	@Override
	public void start() throws LiveViewException, InterruptedException {
		// Create a new ExcelTable for each file
		for (String t : pathNames) {
			ExcelTable et=new ExcelTable(helper, t);
			etList.add(et);
		}
	}

	@Override
	public void shutdown() {
		for (ExcelTable et : etList) {
			et.shutdown();
		}
	}
	
}
